## RKWard-binary-0.6.5_OSX10.9_KDE-4.14.3_src.tar

=== CMakeLists.txt ===
#===============================================================================
# Setup Project
#===============================================================================

cmake_minimum_required(VERSION 2.8.8)

if (POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # Set MACOSX_RPATH=YES by default
endif()

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  project(libunwind)

  # Rely on llvm-config.
  set(CONFIG_OUTPUT)
  find_program(LLVM_CONFIG "llvm-config")
  if (DEFINED LLVM_PATH)
    set(LLVM_INCLUDE_DIR ${LLVM_INCLUDE_DIR} CACHE PATH "Path to llvm/include")
    set(LLVM_PATH ${LLVM_PATH} CACHE PATH "Path to LLVM source tree")
    set(LLVM_MAIN_SRC_DIR ${LLVM_PATH})
    set(LLVM_CMAKE_PATH "${LLVM_PATH}/cmake/modules")
  elseif (LLVM_CONFIG)
    message(STATUS "Found LLVM_CONFIG as ${LLVM_CONFIG}")
    set(CONFIG_COMMAND ${LLVM_CONFIG} "--includedir" "--prefix" "--src-root")
    execute_process(COMMAND ${CONFIG_COMMAND}
                    RESULT_VARIABLE HAD_ERROR
                    OUTPUT_VARIABLE CONFIG_OUTPUT)
    if (NOT HAD_ERROR)
      string(REGEX REPLACE "[ \t]*[\r\n]+[ \t]*" ";"
             CONFIG_OUTPUT ${CONFIG_OUTPUT})
    else ()
      string(REPLACE ";" " " CONFIG_COMMAND_STR "${CONFIG_COMMAND}")
      message(STATUS "${CONFIG_COMMAND_STR}")
      message(FATAL_ERROR "llvm-config failed with status ${HAD_ERROR}")
    endif ()

    list(GET CONFIG_OUTPUT 0 INCLUDE_DIR)
    list(GET CONFIG_OUTPUT 1 LLVM_OBJ_ROOT)
    list(GET CONFIG_OUTPUT 2 MAIN_SRC_DIR)

    set(LLVM_INCLUDE_DIR ${INCLUDE_DIR} CACHE PATH "Path to llvm/include")
    set(LLVM_BINARY_DIR ${LLVM_OBJ_ROOT} CACHE PATH "Path to LLVM build tree")
    set(LLVM_MAIN_SRC_DIR ${MAIN_SRC_DIR} CACHE PATH "Path to LLVM source tree")
    set(LLVM_CMAKE_PATH "${LLVM_BINARY_DIR}/share/llvm/cmake")
    set(LLVM_LIT_PATH "${LLVM_PATH}/utils/lit/lit.py")
  else ()
    message(FATAL_ERROR "llvm-config not found and LLVM_MAIN_SRC_DIR not defined. "
                        "Reconfigure with -DLLVM_CONFIG=path/to/llvm-config "
                        "or -DLLVM_PATH=path/to/llvm-source-root.")
  endif ()

  if (EXISTS ${LLVM_CMAKE_PATH})
    list(APPEND CMAKE_MODULE_PATH "${LLVM_CMAKE_PATH}")
    include("${LLVM_CMAKE_PATH}/AddLLVM.cmake")
    include("${LLVM_CMAKE_PATH}/HandleLLVMOptions.cmake")
  else ()
    message(FATAL_ERROR "Not found: ${LLVM_CMAKE_PATH}")
  endif ()

  set(PACKAGE_NAME libunwind)
  set(PACKAGE_VERSION 3.7.0)
  set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
  set(PACKAGE_BUGREPORT "llvm-bugs@lists.llvm.org")

  if (EXISTS ${LLVM_MAIN_SRC_DIR}/utils/lit/lit.py)
    set(LLVM_LIT ${LLVM_MAIN_SRC_DIR}/utils/lit/lit.py)
  else ()
    # Seek installed Lit.
    find_program(LLVM_LIT "lit.py" ${LLVM_MAIN_SRC_DIR}/utils/lit
                 DOC "Path to lit.py")
  endif ()

  if (LLVM_LIT)
    # Define the default arguments to use with 'lit', and an option for the user
    # to override.
    set(LIT_ARGS_DEFAULT "-sv")
    if (MSVC OR XCODE)
      set(LIT_ARGS_DEFAULT "${LIT_ARGS_DEFAULT} --no-progress-bar")
    endif ()
    set(LLVM_LIT_ARGS "${LIT_ARGS_DEFAULT}" CACHE STRING "Default options for lit")

    # On Win32 hosts, provide an option to specify the path to the GnuWin32 tools.
    if (WIN32 AND NOT CYGWIN)
      set(LLVM_LIT_TOOLS_DIR "" CACHE PATH "Path to GnuWin32 tools")
    endif ()
  else ()
    set(LLVM_INCLUDE_TESTS OFF)
  endif ()

  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib${LLVM_LIBDIR_SUFFIX})
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib${LLVM_LIBDIR_SUFFIX})
else()
  set(LLVM_MAIN_SRC_DIR "${CMAKE_SOURCE_DIR}" CACHE PATH "Path to LLVM source tree")
  set(LLVM_LIT "${CMAKE_SOURCE_DIR}/utils/lit/lit.py")
endif()

#===============================================================================
# Setup CMake Options
#===============================================================================

# Define options.
option(LIBUNWIND_ENABLE_ASSERTIONS "Enable assertions independent of build mode." ON)
option(LIBUNWIND_ENABLE_PEDANTIC "Compile with pedantic enabled." ON)
option(LIBUNWIND_ENABLE_WERROR "Fail and stop if a warning is triggered." OFF)
option(LIBUNWIND_ENABLE_SHARED "Build libunwind as a shared library." ON)

set(LIBUNWIND_GCC_TOOLCHAIN "" CACHE STRING "GCC toolchain for cross compiling.")
set(LIBUNWIND_SYSROOT "" CACHE STRING "Sysroot for cross compiling.")

#===============================================================================
# Configure System
#===============================================================================

# Add path for custom modules
set(CMAKE_MODULE_PATH
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
    ${CMAKE_MODULE_PATH})

# Configure compiler.
include(config-ix)

set(LIBUNWIND_COMPILER    ${CMAKE_CXX_COMPILER})
set(LIBUNWIND_SOURCE_DIR  ${CMAKE_CURRENT_SOURCE_DIR})
set(LIBUNWIND_BINARY_DIR  ${CMAKE_CURRENT_BINARY_DIR})
set(LIBUNWIND_LIBRARY_DIR ${CMAKE_BINARY_DIR}/lib${LLVM_LIBDIR_SUFFIX})

#===============================================================================
# Setup Compiler Flags
#===============================================================================

# Get required flags.
macro(append_if list condition var)
  if (${condition})
    list(APPEND ${list} ${var})
  endif()
endmacro()

set(LIBUNWIND_C_FLAGS "")
set(LIBUNWIND_CXX_FLAGS "")
set(LIBUNWIND_COMPILE_FLAGS "")
set(LIBUNWIND_LINK_FLAGS "")

append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WERROR_FLAG -Werror=return-type)

# Get warning flags
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_W_FLAG -W)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WALL_FLAG -Wall)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WCHAR_SUBSCRIPTS_FLAG -Wchar-subscripts)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WCONVERSION_FLAG -Wconversion)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WMISMATCHED_TAGS_FLAG -Wmismatched-tags)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WMISSING_BRACES_FLAG -Wmissing-braces)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WNEWLINE_EOF_FLAG -Wnewline-eof)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WNO_UNUSED_FUNCTION_FLAG -Wno-unused-function)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WSHADOW_FLAG -Wshadow)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WSHORTEN_64_TO_32_FLAG -Wshorten-64-to-32)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WSIGN_COMPARE_FLAG -Wsign-compare)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WSIGN_CONVERSION_FLAG -Wsign-conversion)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WSTRICT_ALIASING_FLAG -Wstrict-aliasing=2)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WSTRICT_OVERFLOW_FLAG -Wstrict-overflow=4)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WUNUSED_PARAMETER_FLAG -Wunused-parameter)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WUNUSED_VARIABLE_FLAG -Wunused-variable)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WWRITE_STRINGS_FLAG -Wwrite-strings)
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WUNDEF_FLAG -Wundef)

if (LIBUNWIND_ENABLE_WERROR)
  append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WERROR_FLAG -Werror)
  append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WX_FLAG -WX)
else()
  append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_WNO_ERROR_FLAG -Wno-error)
  append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_NO_WX_FLAG -WX-)
endif()

if (LIBUNWIND_ENABLE_PEDANTIC)
  append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_PEDANTIC_FLAG -pedantic)
endif()

# Get feature flags.
# Exceptions
# Catches C++ exceptions only and tells the compiler to assume that extern C
# functions never throw a C++ exception.
append_if(LIBUNWIND_CXX_FLAGS LIBUNWIND_HAS_FSTRICT_ALIASING_FLAG -fstrict-aliasing)
append_if(LIBUNWIND_CXX_FLAGS LIBUNWIND_HAS_EHSC_FLAG -EHsc)

append_if(LIBUNWIND_C_FLAGS LIBUNWIND_HAS_FUNWIND_TABLES -funwind-tables)

# Assert
string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
if (LIBUNWIND_ENABLE_ASSERTIONS)
  # MSVC doesn't like _DEBUG on release builds. See PR 4379.
  if (NOT MSVC)
    list(APPEND LIBUNWIND_COMPILE_FLAGS -D_DEBUG)
  endif ()

  # On Release builds cmake automatically defines NDEBUG, so we
  # explicitly undefine it:
  if (uppercase_CMAKE_BUILD_TYPE STREQUAL "RELEASE")
    list(APPEND LIBUNWIND_COMPILE_FLAGS -UNDEBUG)
  endif ()
else()
  if (NOT uppercase_CMAKE_BUILD_TYPE STREQUAL "RELEASE")
    list(APPEND LIBUNWIND_COMPILE_FLAGS -DNDEBUG)
  endif ()
endif ()

# This is the _ONLY_ place where add_definitions is called.
if (MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif ()

append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_TARGET_TRIPLE
          "-target ${LIBUNWIND_TARGET_TRIPLE}")
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_GCC_TOOLCHAIN
          "-gcc-toolchain ${LIBUNWIND_GCC_TOOLCHAIN}")
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_SYSROOT
          "--sysroot=${LIBUNWIND_SYSROOT}")

#===============================================================================
# Setup Source Code
#===============================================================================

include_directories(include)

add_subdirectory(src)

=== lib/CMakeLists.txt ===
INCLUDE(CheckFunctionExists)

INSTALL(FILES zip.h DESTINATION include)

# from http://www.cmake.org/Wiki/CMakeMacroLibtoolFile
MACRO(GET_TARGET_PROPERTY_WITH_DEFAULT _variable _target _property _default_value)
  
  GET_TARGET_PROPERTY (${_variable} ${_target} ${_property})
  IF (${_variable} STREQUAL NOTFOUND)
    SET (${_variable} ${_default_value})
  ENDIF (${_variable} STREQUAL NOTFOUND)
  
ENDMACRO (GET_TARGET_PROPERTY_WITH_DEFAULT)
  
MACRO(CREATE_LIBTOOL_FILE _target _install_DIR)
  GET_TARGET_PROPERTY(_target_location ${_target} LOCATION)
  GET_TARGET_PROPERTY_WITH_DEFAULT(_target_static_lib ${_target} STATIC_LIB "")
  GET_TARGET_PROPERTY_WITH_DEFAULT(_target_dependency_libs ${_target} LT_DEPENDENCY_LIBS "")
  GET_TARGET_PROPERTY_WITH_DEFAULT(_target_current ${_target} LT_VERSION_CURRENT 0)
  GET_TARGET_PROPERTY_WITH_DEFAULT(_target_age ${_target} LT_VERSION_AGE 0)
  GET_TARGET_PROPERTY_WITH_DEFAULT(_target_revision ${_target} LT_VERSION_REVISION 0)
  GET_TARGET_PROPERTY_WITH_DEFAULT(_target_installed ${_target} LT_INSTALLED yes)
  GET_TARGET_PROPERTY_WITH_DEFAULT(_target_shouldnotlink ${_target} LT_SHOULDNOTLINK yes)
  GET_TARGET_PROPERTY_WITH_DEFAULT(_target_dlopen ${_target} LT_DLOPEN "")
  GET_TARGET_PROPERTY_WITH_DEFAULT(_target_dlpreopen ${_target} LT_DLPREOPEN "")
  GET_FILENAME_COMPONENT(_laname ${_target_location} NAME_WE)
  GET_FILENAME_COMPONENT(_soname ${_target_location} NAME)
  SET(_laname ${_laname}.la)
  FILE(WRITE ${_laname} "# ${_laname} - a libtool library file, generated by cmake \n")
  FILE(APPEND ${_laname} "# The name that we can dlopen(3).\n")
  FILE(APPEND ${_laname} "dlname='${_soname}'\n")
  FILE(APPEND ${_laname} "# Names of this library\n")
  FILE(APPEND ${_laname} "library_names='${_soname}.${_target_current}.${_target_age}.${_target_revision} ${_soname}.${_target_current} ${_soname}'\n")
  FILE(APPEND ${_laname} "# The name of the static archive\n")
  FILE(APPEND ${_laname} "old_library='${_target_static_lib}'\n")
  FILE(APPEND ${_laname} "# Libraries that this one depends upon.\n")
  FILE(APPEND ${_laname} "dependency_libs='${_target_dependency_libs}'\n")
  FILE(APPEND ${_laname} "# Version information.\n")
  FILE(APPEND ${_laname} "current=${_target_current}\n")
  FILE(APPEND ${_laname} "age=${_target_age}\n")
  FILE(APPEND ${_laname} "revision=${_target_revision}\n")
  FILE(APPEND ${_laname} "# Is this an already installed library?\n")
  FILE(APPEND ${_laname} "installed=${_target_installed}\n")
  FILE(APPEND ${_laname} "# Should we warn about portability when linking against -modules?\n")
  FILE(APPEND ${_laname} "shouldnotlink=${_target_shouldnotlink}\n")
  FILE(APPEND ${_laname} "# Files to dlopen/dlpreopen\n")
  FILE(APPEND ${_laname} "dlopen='${_target_dlopen}'\n")
  FILE(APPEND ${_laname} "dlpreopen='${_target_dlpreopen}'\n")
  FILE(APPEND ${_laname} "# Directory that this library needs to be installed in:\n")
  FILE(APPEND ${_laname} "libdir='${CMAKE_INSTALL_PREFIX}/${_install_DIR}'\n")
  INSTALL( FILES ${_laname} ${_soname}
    DESTINATION ${CMAKE_INSTALL_PREFIX}${_install_DIR})
ENDMACRO(CREATE_LIBTOOL_FILE)
 
SET(LIBZIP_SOURCES
  zip_add.c
  zip_add_dir.c
  zip_add_entry.c
  zip_close.c
  zip_delete.c
  zip_dir_add.c
  zip_dirent.c
  zip_discard.c
  zip_entry.c
  zip_err_str.c
  zip_error.c
  zip_error_clear.c
  zip_error_get.c
  zip_error_get_sys_type.c
  zip_error_strerror.c
  zip_error_to_str.c
  zip_extra_field.c
  zip_extra_field_api.c
  zip_fclose.c
  zip_fdopen.c
  zip_file_add.c
  zip_file_error_clear.c
  zip_file_error_get.c
  zip_file_get_comment.c
  zip_file_get_offset.c
  zip_file_rename.c
  zip_file_replace.c
  zip_file_set_comment.c
  zip_file_strerror.c
  zip_filerange_crc.c
  zip_fopen.c
  zip_fopen_encrypted.c
  zip_fopen_index.c
  zip_fopen_index_encrypted.c
  zip_fread.c
  zip_get_archive_comment.c
  zip_get_archive_flag.c
  zip_get_compression_implementation.c
  zip_get_encryption_implementation.c
  zip_get_file_comment.c
  zip_get_name.c
  zip_get_num_entries.c
  zip_get_num_files.c
  zip_memdup.c
  zip_name_locate.c
  zip_new.c
  zip_open.c
  zip_rename.c
  zip_replace.c
  zip_set_archive_comment.c
  zip_set_archive_flag.c
  zip_set_default_password.c
  zip_set_file_comment.c
  zip_set_file_compression.c
  zip_set_name.c
  zip_source_buffer.c
  zip_source_close.c
  zip_source_crc.c
  zip_source_deflate.c
  zip_source_error.c
  zip_source_file.c
  zip_source_filep.c
  zip_source_free.c
  zip_source_function.c
  zip_source_layered.c
  zip_source_open.c
  zip_source_pkware.c
  zip_source_pop.c
  zip_source_read.c
  zip_source_stat.c
  zip_source_window.c
  zip_source_zip.c
  zip_source_zip_new.c
  zip_stat.c
  zip_stat_index.c
  zip_stat_init.c
  zip_strerror.c
  zip_string.c
  zip_unchange.c
  zip_unchange_all.c
  zip_unchange_archive.c
  zip_unchange_data.c
  zip_utf-8.c
)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_BINARY_DIR}/..)

# XXX: distribute instead?
#ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/zip_err_str.c
#  COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/make_zip_err_str.sh
#    ${CMAKE_CURRENT_SOURCE_DIR}/zip.h
#    ${CMAKE_CURRENT_BINARY_DIR}/zip_err_str.c
#  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/zip.h
#    ${CMAKE_CURRENT_SOURCE_DIR}/make_zip_err_str.sh
#)
CHECK_FUNCTION_EXISTS(mkstemp HAVE_MKSTEMP)
IF(NOT HAVE_MKSTEMP)
  SET(LIBZIP_EXTRA_FILES mkstemp.c)
ENDIF(NOT HAVE_MKSTEMP)

ADD_LIBRARY(zip SHARED ${LIBZIP_SOURCES} ${LIBZIP_EXTRA_FILES})
SET_TARGET_PROPERTIES(zip PROPERTIES VERSION 3.0 SOVERSION 3 )
TARGET_LINK_LIBRARIES(zip ${ZLIB_LIBRARY})
INSTALL(TARGETS zip
	ARCHIVE DESTINATION lib
	LIBRARY DESTINATION lib)
#CREATE_LIBTOOL_FILE(zip lib)

=== man/CMakeLists.txt ===
SET(MDOC3_PAGES
  libzip.mdoc
  zip_add.mdoc
  zip_add_dir.mdoc
  zip_close.mdoc
  zip_delete.mdoc
  zip_dir_add.mdoc
  zip_discard.mdoc
  zip_error_clear.mdoc
  zip_error_get.mdoc
  zip_error_get_sys_type.mdoc
  zip_error_to_str.mdoc
  zip_errors.mdoc
  zip_fclose.mdoc
  zip_fdopen.mdoc
  zip_file_add.mdoc
  zip_file_extra_field_delete.mdoc
  zip_file_extra_field_get.mdoc
  zip_file_extra_field_set.mdoc
  zip_file_extra_fields_count.mdoc
  zip_file_get_comment.mdoc
  zip_file_rename.mdoc
  zip_file_set_comment.mdoc
  zip_file_strerror.mdoc
  zip_fopen.mdoc
  zip_fopen_encrypted.mdoc
  zip_fread.mdoc
  zip_get_archive_comment.mdoc
  zip_get_archive_flag.mdoc
  zip_get_file_comment.mdoc
  zip_get_name.mdoc
  zip_get_num_entries.mdoc
  zip_get_num_files.mdoc
  zip_name_locate.mdoc
  zip_open.mdoc
  zip_rename.mdoc
  zip_set_archive_comment.mdoc
  zip_set_archive_flag.mdoc
  zip_set_default_password.mdoc
  zip_set_file_comment.mdoc
  zip_set_file_compression.mdoc
  zip_source_buffer.mdoc
  zip_source_file.mdoc
  zip_source_filep.mdoc
  zip_source_free.mdoc
  zip_source_function.mdoc
  zip_source_zip.mdoc
  zip_stat.mdoc
  zip_stat_init.mdoc
  zip_unchange.mdoc
  zip_unchange_all.mdoc
  zip_unchange_archive.mdoc
)
SET(MDOC1_PAGES
  zipcmp.mdoc
  zipmerge.mdoc
  ziptorrent.mdoc
)
SET(MDOC_PAGES ${MDOC1_PAGES} ${MDOC3_PAGES})
STRING(REGEX REPLACE .mdoc "" MAN1_PAGES "${MDOC1_PAGES}")
STRING(REGEX REPLACE .mdoc "" MAN3_PAGES "${MDOC3_PAGES}")
SET(MAN_PAGES ${MAN1_PAGES} ${MAN3_PAGES})

IF(CMAKE_SYSTEM_NAME MATCHES BSD)
  SET(MANFMT mdoc)
ELSE(CMAKE_SYSTEM_NAME MATCHES BSD)
  SET(MANFMT man)
ENDif(CMAKE_SYSTEM_NAME MATCHES BSD)

# installation

SET(MAN_PATH man)

FOREACH(MAN_PAGE ${MAN1_PAGES})
  INSTALL(FILES ${MAN_PAGE}.${MANFMT} DESTINATION ${MAN_PATH}/man1
    RENAME ${MAN_PAGE}.1)
ENDFOREACH(MAN_PAGE ${PROGRAMS})
FOREACH(MAN_PAGE ${MAN3_PAGES})
  INSTALL(FILES ${MAN_PAGE}.${MANFMT} DESTINATION ${MAN_PATH}/man3
    RENAME ${MAN_PAGE}.3)
ENDFOREACH(MAN_PAGE ${PROGRAMS})
# XXX: usually symlinks, but I only know how to do this way
INSTALL(FILES zip_error_clear.${MANFMT} DESTINATION ${MAN_PATH}/man3
  RENAME zip_file_error_clear.3)
INSTALL(FILES zip_error_get.${MANFMT} DESTINATION ${MAN_PATH}/man3
  RENAME zip_file_error_get.3)
INSTALL(FILES zip_file_add.${MANFMT} DESTINATION ${MAN_PATH}/man3
  RENAME zip_file_replace.3)
INSTALL(FILES zip_file_extra_field_delete.${MANFMT} DESTINATION ${MAN_PATH}/man3
  RENAME zip_file_extra_field_delete_by_id.3)
INSTALL(FILES zip_file_extra_field_get.${MANFMT} DESTINATION ${MAN_PATH}/man3
  RENAME zip_file_extra_field_get_by_id.3)
INSTALL(FILES zip_file_extra_fields_count.${MANFMT} DESTINATION ${MAN_PATH}/man3
  RENAME zip_file_extra_fields_count_by_id.3)
INSTALL(FILES zip_fopen.${MANFMT} DESTINATION ${MAN_PATH}/man3
  RENAME zip_fopen_index.3)
INSTALL(FILES zip_fopen_encrypted.${MANFMT} DESTINATION ${MAN_PATH}/man3
  RENAME zip_fopen_index_encrypted.3)
INSTALL(FILES zip_add.${MANFMT} DESTINATION ${MAN_PATH}/man3
  RENAME zip_replace.3)
INSTALL(FILES zip_stat.${MANFMT} DESTINATION ${MAN_PATH}/man3
  RENAME zip_stat_index.3)
INSTALL(FILES zip_file_strerror.${MANFMT} DESTINATION ${MAN_PATH}/man3
  RENAME zip_strerror.3)

# custom maintainer targets

#FOREACH(MAN ${MAN_PAGES})
#  ADD_CUSTOM_TARGET(${MAN}.man
#    DEPENDS ${MAN}.mdoc
#    COMMAND mdoc2man ${CMAKE_CURRENT_SOURCE_DIR}/${MAN}.mdoc > ${MAN}.new
#    COMMAND diff -I NiH ${MAN}.new ${CMAKE_CURRENT_SOURCE_DIR}/${MAN}.man || mv ${MAN}.new ${CMAKE_CURRENT_SOURCE_DIR}/${MAN}.man
#    COMMAND rm -f ${MAN}.new
#    COMMENT Updating man page ${MAN}.man
#    )
#  ADD_CUSTOM_TARGET(${MAN}.html
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${MAN}.mdoc
#    COMMAND nroff -mdoc2html ${CMAKE_CURRENT_SOURCE_DIR}/${MAN}.mdoc | sed -e "s,../html[0-9]/,," > ${MAN}.html
#    COMMENT Updating HTML page ${MAN}.html
#    )
#ENDFOREACH(MAN)

#STRING(REGEX REPLACE .mdoc .man MANDEPEND "${MDOC_PAGES}")
#ADD_CUSTOM_TARGET(update-man
#  DEPENDS ${MANDEPEND})

#STRING(REGEX REPLACE .mdoc .html HTMLDEPEND "${MDOC_PAGES}")
#ADD_CUSTOM_TARGET(update-html
#  DEPENDS ${HTMLDEPEND})

# XXX: strange error:
#[ 94%] zipcmp.html
#[ 97%] Built target zipcmp.html
#[ 97%] zipmerge.html
#[100%] Built target zipmerge.html
#make: don't know how to make zipcmp.html. Stop

# XXX: why are all the man pages rebuilt on a second 'make update-html'?

=== misc/Makefile ===
export USE_APPLE_PB_SUPPORT = all

ifneq "" "$(SDKROOT)"
  SDK = -isysroot $(SDKROOT)
  CC = $(shell xcrun -find -sdk $(SDKROOT) cc)
  CXX = $(shell xcrun -find -sdk $(SDKROOT) c++)
  DSYMUTIL = $(shell xcrun -find -sdk ${SDKROOT} dsymutil)
  LIBTOOL = $(shell xcrun -find -sdk $(SDKROOT) libtool)
else
  DSYMUTIL = dsymutil
  LIBTOOL = libtool
endif

OFLAG = -Os
LTO = -DLTO_SUPPORT
TRIE = -DTRIE_SUPPORT
CFLAGS = $(OFLAG) $(LTO) $(TRIE) -g -Wall \
	 -I$(SRCROOT) -I$(SRCROOT)/../include -I$(OFILE_DIR) $(SDK) \
	 -I$(DT_TOOLCHAIN_DIR)/usr/local/include

LIBSTUFF = -L$(SYMROOT)/../libstuff -lstuff
CXXLIB = -stdlib=libc++

ifeq "" "$(TRIE)"
  LIB_PRUNETRIE =
  else
  LIB_PRUNETRIE = -L$(DT_TOOLCHAIN_DIR)/usr/local/lib -lprunetrie
endif

MKDIRS = /bin/mkdir -p
SRCROOT = .
OBJROOT = .
OFILE_DIR = $(OBJROOT)
VPATH = $(OFILE_DIR)
SYMROOT = .

BINDIR = /bin
USRBINDIR = /usr/bin
LOCBINDIR = /usr/local/bin
LOCLIBDIR = /usr/local/lib

CFILES1 = libtool.c
CFILES2 = lipo.c size.c strings.c nm.c checksyms.c inout.c \
	 indr.c strip.c segedit.c cmpdylib.c \
	 pagestuff.c redo_prebinding.c seg_addr_table.c \
	 check_dylib.c seg_hack.c install_name_tool.c \
	 codesign_allocate.c ctf_insert.c bitcode_strip.c
INSTALL_FILES = $(CFILES1) $(CFILES2) Makefile notes Info.plist

OS_PROGS = lipo.NEW strings.NEW

PROGS = $(OS_PROGS) size.NEW nm.NEW libtool.NEW checksyms.NEW \
	indr.NEW strip.NEW nmedit.NEW segedit.NEW cmpdylib.NEW \
	pagestuff.NEW redo_prebinding.NEW seg_addr_table.NEW check_dylib.NEW \
	seg_hack.NEW install_name_tool.NEW codesign_allocate.NEW \
	ctf_insert.NEW bitcode_strip.NEW

all:	$(OFILE_DIR) $(SYMROOT) $(PROGS) lib_ofiles

os_tools: $(OFILE_DIR) $(SYMROOT) $(OS_PROGS)

lib_ofiles: $(OFILE_DIR) $(SYMROOT) libredo_prebinding.a

.c.o:
	$(CC) $(CFLAGS) $(RC_CFLAGS) -c -o $(OFILE_DIR)/$*.o $<

libredo_prebinding.o: redo_prebinding.c
	$(CC) $(CFLAGS) $(RC_CFLAGS) -c \
		-o $(OFILE_DIR)/$*.o $(SRCROOT)/redo_prebinding.c -DLIBRARY_API

checksyms.NEW: checksyms.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/checksyms.private.o \
		$(OFILE_DIR)/checksyms.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/checksyms.NEW \
		$(OFILE_DIR)/checksyms.private.o
	$(DSYMUTIL) $(SYMROOT)/checksyms.NEW

cmpdylib.NEW: cmpdylib.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/cmpdylib.private.o \
		$(OFILE_DIR)/cmpdylib.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/cmpdylib.NEW \
		$(OFILE_DIR)/cmpdylib.private.o
	$(DSYMUTIL) $(SYMROOT)/cmpdylib.NEW

lipo.NEW: lipo.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/lipo.private.o \
		$(OFILE_DIR)/lipo.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/lipo.NEW \
		$(OFILE_DIR)/lipo.private.o
	$(DSYMUTIL) $(SYMROOT)/lipo.NEW

size.NEW: size.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/size.private.o \
		$(OFILE_DIR)/size.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/size.NEW \
		$(OFILE_DIR)/size.private.o
	$(DSYMUTIL) $(SYMROOT)/size.NEW

strings.NEW: strings.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/strings.private.o \
		$(OFILE_DIR)/strings.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/strings.NEW \
		$(OFILE_DIR)/strings.private.o
	$(DSYMUTIL) $(SYMROOT)/strings.NEW

nm.NEW: nm.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/nm.private.o \
		$(OFILE_DIR)/nm.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/nm.NEW \
		$(OFILE_DIR)/nm.private.o
	$(DSYMUTIL) $(SYMROOT)/nm.NEW

libtool.NEW: libtool.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/libtool.private.o \
		$(OFILE_DIR)/libtool.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/libtool.NEW \
		$(OFILE_DIR)/libtool.private.o
	$(DSYMUTIL) $(SYMROOT)/libtool.NEW

redo_prebinding.NEW: redo_prebinding.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/redo_prebinding.private.o \
		$(OFILE_DIR)/redo_prebinding.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/redo_prebinding.NEW \
		$(OFILE_DIR)/redo_prebinding.private.o
	$(DSYMUTIL) $(SYMROOT)/redo_prebinding.NEW

libredo_prebinding.a: libredo_prebinding.o
	$(CC) $(RC_CFLAGS) -nostdlib -r -o $(OBJROOT)/libredo.o \
		libredo_prebinding.o $(LIBSTUFF)
	$(LIBTOOL) -static -o $(SYMROOT)/libredo_prebinding.a $(OBJROOT)/libredo.o

seg_addr_table.NEW: seg_addr_table.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/seg_addr_table.private.o \
		$(OFILE_DIR)/seg_addr_table.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/seg_addr_table.NEW \
		$(OFILE_DIR)/seg_addr_table.private.o
	$(DSYMUTIL) $(SYMROOT)/seg_addr_table.NEW

check_dylib.NEW: check_dylib.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/check_dylib.private.o \
		$(OFILE_DIR)/check_dylib.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/check_dylib.NEW \
		$(OFILE_DIR)/check_dylib.private.o
	$(DSYMUTIL) $(SYMROOT)/check_dylib.NEW

inout.NEW: inout.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/inout.private.o \
		$(OFILE_DIR)/inout.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/inout.NEW \
		$(OFILE_DIR)/inout.private.o
	$(DSYMUTIL) $(SYMROOT)/inout.NEW

codesign_allocate.NEW: codesign_allocate.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/codesign_allocate.private.o \
		$(OFILE_DIR)/codesign_allocate.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/codesign_allocate.NEW \
		-sectcreate __TEXT __info_plist Info.plist \
		$(OFILE_DIR)/codesign_allocate.private.o
	$(DSYMUTIL) $(SYMROOT)/codesign_allocate.NEW

ctf_insert.NEW: ctf_insert.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/ctf_insert.private.o \
		$(OFILE_DIR)/ctf_insert.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/ctf_insert.NEW \
		$(OFILE_DIR)/ctf_insert.private.o
	$(DSYMUTIL) $(SYMROOT)/ctf_insert.NEW

seg_hack.NEW: seg_hack.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/seg_hack.private.o \
		$(OFILE_DIR)/seg_hack.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/seg_hack.NEW \
		$(OFILE_DIR)/seg_hack.private.o
	$(DSYMUTIL) $(SYMROOT)/seg_hack.NEW

install_name_tool.NEW: install_name_tool.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/install_name_tool.private.o \
		$(OFILE_DIR)/install_name_tool.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/install_name_tool.NEW \
		$(OFILE_DIR)/install_name_tool.private.o
	$(DSYMUTIL) $(SYMROOT)/install_name_tool.NEW

indr.NEW: indr.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/indr.private.o \
		$(OFILE_DIR)/indr.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/indr.NEW \
		$(OFILE_DIR)/indr.private.o
	$(DSYMUTIL) $(SYMROOT)/indr.NEW

strip.NEW: strip.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/strip.private.o \
		$(OFILE_DIR)/strip.o $(LIBSTUFF)
	$(CXX) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/strip.NEW \
		$(OFILE_DIR)/strip.private.o $(LIB_PRUNETRIE) $(CXXLIB)
	$(DSYMUTIL) $(SYMROOT)/strip.NEW

nmedit.NEW: nmedit.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/nmedit.private.o \
		$(OFILE_DIR)/nmedit.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/nmedit.NEW \
		$(OFILE_DIR)/nmedit.private.o
	$(DSYMUTIL) $(SYMROOT)/nmedit.NEW

nmedit.o: strip.c
	$(CC) $(CFLAGS) $(RC_CFLAGS) -c \
		-o $(OFILE_DIR)/nmedit.o $(SRCROOT)/strip.c -DNMEDIT

segedit.NEW: segedit.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/segedit.private.o \
		$(OFILE_DIR)/segedit.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/segedit.NEW \
		$(OFILE_DIR)/segedit.private.o
	$(DSYMUTIL) $(SYMROOT)/segedit.NEW

pagestuff.NEW: pagestuff.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/pagestuff.private.o \
		$(OFILE_DIR)/pagestuff.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/pagestuff.NEW \
		$(OFILE_DIR)/pagestuff.private.o
	$(DSYMUTIL) $(SYMROOT)/pagestuff.NEW

bitcode_strip.NEW: bitcode_strip.o
	$(CC) $(RC_CFLAGS) -nostdlib -r \
		-o $(OBJROOT)/bitcode_strip.private.o \
		$(OFILE_DIR)/bitcode_strip.o $(LIBSTUFF)
	$(CC) $(RC_CFLAGS) $(SDK) -o $(SYMROOT)/bitcode_strip.NEW \
		$(OFILE_DIR)/bitcode_strip.private.o
	$(DSYMUTIL) $(SYMROOT)/bitcode_strip.NEW


clean: shlib_clean
	-rm -f \
	$(SYMROOT)/lipo.NEW \
	$(SYMROOT)/size.NEW \
	$(SYMROOT)/strings.NEW \
	$(SYMROOT)/nm.NEW \
	$(SYMROOT)/libtool.NEW \
	$(SYMROOT)/checksyms.NEW \
	$(SYMROOT)/seg_addr_table.NEW \
	$(SYMROOT)/check_dylib.NEW \
	$(SYMROOT)/inout.NEW \
	$(SYMROOT)/codesign_allocate.NEW \
	$(SYMROOT)/ctf_insert.NEW \
	$(SYMROOT)/seg_hack.NEW \
	$(SYMROOT)/install_name_tool.NEW \
	$(SYMROOT)/codesign_allocate.NEW \
	$(SYMROOT)/indr.NEW \
	$(SYMROOT)/strip.NEW \
	$(SYMROOT)/nmedit.NEW \
	$(SYMROOT)/segedit.NEW \
	$(SYMROOT)/pagestuff.NEW \
	$(SYMROOT)/redo_prebinding.NEW \
	$(SYMROOT)/libredo_prebinding.a \
	$(SYMROOT)/cmpdylib.NEW \
	$(SYMROOT)/bitcode_strip.NEW

shlib_clean:
	-rm -f \
	$(OFILE_DIR)/lipo.o \
	$(OFILE_DIR)/size.o \
	$(OFILE_DIR)/strings.o \
	$(OFILE_DIR)/nm.o \
	$(OFILE_DIR)/libtool.o \
	$(OFILE_DIR)/make.h \
	$(OFILE_DIR)/checksyms.o \
	$(OFILE_DIR)/inout.o \
	$(OFILE_DIR)/codesign_allocate.o \
	$(OFILE_DIR)/ctf_insert.o \
	$(OFILE_DIR)/seg_hack.o \
	$(OFILE_DIR)/install_name_tool.o \
	$(OFILE_DIR)/indr.o \
	$(OFILE_DIR)/segedit.o \
	$(OFILE_DIR)/pagestuff.o \
	$(OFILE_DIR)/redo_prebinding.o \
	$(OFILE_DIR)/libredo_prebinding.o \
	$(OFILE_DIR)/libredo.o \
	$(OFILE_DIR)/seg_addr_table.o \
	$(OFILE_DIR)/check_dylib.o \
	$(OFILE_DIR)/cmpdylib.o \
	$(OFILE_DIR)/nmedit.o \
	$(OFILE_DIR)/strip.o \
	$(OFILE_DIR)/lipo.private.o \
	$(OFILE_DIR)/size.private.o \
	$(OFILE_DIR)/strings.private.o \
	$(OFILE_DIR)/nm.private.o \
	$(OFILE_DIR)/bitcode_strip.o \
	$(OFILE_DIR)/libtool.private.o \
	$(OFILE_DIR)/checksyms.private.o \
	$(OFILE_DIR)/inout.private.o \
	$(OFILE_DIR)/codesign_allocate.private.o \
	$(OFILE_DIR)/ctf_insert.private.o \
	$(OFILE_DIR)/seg_hack.private.o \
	$(OFILE_DIR)/install_name_tool.private.o \
	$(OFILE_DIR)/indr.private.o \
	$(OFILE_DIR)/segedit.private.o \
	$(OFILE_DIR)/pagestuff.private.o \
	$(OFILE_DIR)/redo_prebinding.private.o \
	$(OFILE_DIR)/seg_addr_table.private.o \
	$(OFILE_DIR)/check_dylib.private.o \
	$(OFILE_DIR)/cmpdylib.private.o \
	$(OFILE_DIR)/nmedit.private.o \
	$(OFILE_DIR)/strip.private.o \
	$(OFILE_DIR)/bitcode_strip.private.o
	-rm -f make.out
	-rm -r -f *dSYM

install: all dt_install os_tools_install

install_os_tools: os_tools os_tools_install

os_tools_install:
	$(MKDIRS) $(DSTROOT)$(USRBINDIR)
	install -c -s -m 555 $(SYMROOT)/strings.NEW \
		$(DSTROOT)$(USRBINDIR)/strings
	install -c -s -m 555 $(SYMROOT)/lipo.NEW $(DSTROOT)$(USRBINDIR)/lipo

dt_install:
	$(MKDIRS) $(DSTROOT)$(USRBINDIR)
	install -c -s -m 555 $(SYMROOT)/strip.NEW $(DSTROOT)$(USRBINDIR)/strip
	install -c -s -m 555 $(SYMROOT)/size.NEW $(DSTROOT)$(USRBINDIR)/size
	install -c -s -m 555 $(SYMROOT)/nm.NEW $(DSTROOT)$(USRBINDIR)/nm
	install -c -s -m 555 $(SYMROOT)/libtool.NEW \
		$(DSTROOT)$(USRBINDIR)/libtool
	(cd $(DSTROOT)$(USRBINDIR); rm -f ranlib; ln -s libtool ranlib)
	install -c -s -m 555 $(SYMROOT)/segedit.NEW \
		$(DSTROOT)$(USRBINDIR)/segedit
	install -c -s -m 555 $(SYMROOT)/cmpdylib.NEW \
			  $(DSTROOT)$(USRBINDIR)/cmpdylib
	install -c -s -m 555 $(SYMROOT)/pagestuff.NEW \
			  $(DSTROOT)$(USRBINDIR)/pagestuff
	install -c -s -m 555 $(SYMROOT)/redo_prebinding.NEW \
			  $(DSTROOT)$(USRBINDIR)/redo_prebinding
	install -c -s -m 555 $(SYMROOT)/nmedit.NEW $(DSTROOT)$(USRBINDIR)/nmedit
	install -c -s -m 555 $(SYMROOT)/install_name_tool.NEW \
			  $(DSTROOT)$(USRBINDIR)/install_name_tool
	install -c -s -m 555 $(SYMROOT)/codesign_allocate.NEW \
			  $(DSTROOT)$(USRBINDIR)/codesign_allocate
	install -c -s -m 555 $(SYMROOT)/ctf_insert.NEW \
			  $(DSTROOT)$(USRBINDIR)/ctf_insert
	install -c -s -m 555 $(SYMROOT)/bitcode_strip.NEW \
			  $(DSTROOT)$(USRBINDIR)/bitcode_strip
	$(MKDIRS) $(DSTROOT)$(LOCBINDIR)
	install -c -s -m 555 $(SYMROOT)/checksyms.NEW \
			  $(DSTROOT)$(LOCBINDIR)/checksyms
	install -c -s -m 555 $(SYMROOT)/seg_addr_table.NEW \
			  $(DSTROOT)$(LOCBINDIR)/seg_addr_table
	install -c -s -m 555 $(SYMROOT)/check_dylib.NEW \
			  $(DSTROOT)$(LOCBINDIR)/check_dylib

=== src/CMakeLists.txt ===
# Get sources

set(LIBUNWIND_CXX_SOURCES
    libunwind.cpp
    Unwind-EHABI.cpp)
append_if(LIBUNWIND_CXX_SOURCES APPLE Unwind_AppleExtras.cpp)

set(LIBUNWIND_C_SOURCES
    UnwindLevel1.c
    UnwindLevel1-gcc-ext.c
    Unwind-sjlj.c)
set_source_files_properties(${LIBUNWIND_C_SOURCES}
                            PROPERTIES
                              COMPILE_FLAGS "-std=c99")

set(LIBUNWIND_ASM_SOURCES
    UnwindRegistersRestore.S
    UnwindRegistersSave.S)
set_source_files_properties(${LIBUNWIND_ASM_SOURCES}
                            PROPERTIES
                              LANGUAGE C)

set(LIBUNWIND_HEADERS
    AddressSpace.hpp
    assembly.h
    CompactUnwinder.hpp
    config.h
    dwarf2.h
    DwarfInstructions.hpp
    DwarfParser.hpp
    libunwind_ext.h
    Registers.hpp
    UnwindCursor.hpp
    unwind_ext.h
    ${CMAKE_CURRENT_SOURCE_DIR}/../include/libunwind.h
    ${CMAKE_CURRENT_SOURCE_DIR}/../include/unwind.h)

append_if(LIBUNWIND_HEADERS APPLE
          "${CMAKE_CURRENT_SOURCE_DIR}/../include/mach-o/compact_unwind_encoding.h")

if (MSVC_IDE)
  # Force them all into the headers dir on MSVC, otherwise they end up at
  # project scope because they don't have extensions.
  source_group("Header Files" FILES ${LIBUNWIND_HEADERS})
endif()

set(LIBUNWIND_SOURCES
    ${LIBUNWIND_CXX_SOURCES}
    ${LIBUNWIND_C_SOURCES}
    ${LIBUNWIND_ASM_SOURCES})

if (LIBUNWIND_ENABLE_SHARED)
  add_library(unwind SHARED ${LIBUNWIND_SOURCES} ${LIBUNWIND_HEADERS})
else()
  add_library(unwind STATIC ${LIBUNWIND_SOURCES} ${LIBUNWIND_HEADERS})
endif ()

# Generate library list.
set(libraries ${LIBUNWINDCXX_ABI_LIBRARIES})
append_if(libraries LIBUNWIND_HAS_C_LIB c)
append_if(libraries LIBUNWIND_HAS_DL_LIB dl)
append_if(libraries LIBUNWIND_HAS_PTHREAD_LIB pthread)

target_link_libraries(unwind ${libraries})

# Setup flags.
append_if(LIBUNWIND_COMPILE_FLAGS LIBUNWIND_HAS_FPIC_FLAG -fPIC)
append_if(LIBUNWIND_CXX_FLAGS LIBUNWIND_HAS_NO_RTTI_FLAG -fno-rtti)

append_if(LIBUNWIND_LINK_FLAGS LIBUNWIND_HAS_NODEFAULTLIBS_FLAG -nodefaultlibs)

if (LIBUNWIND_HAS_NO_EXCEPTIONS_FLAG AND LIBUNWIND_HAS_FUNWIND_TABLES)
  list(APPEND LIBUNWIND_COMPILE_FLAGS -fno-exceptions)
  list(APPEND LIBUNWIND_COMPILE_FLAGS -funwind-tables)
elseif (LIBUNWIND_ENABLE_SHARED)
  message(FATAL_ERROR
          "Compiler doesn't support generation of unwind tables if exception "
          "support is disabled.  Building libunwind DSO with runtime dependency "
          "on C++ ABI library is not supported.")
endif()

if (APPLE)
  list(APPEND LIBUNWIND_COMPILE_FLAGS "-U__STRICT_ANSI__")
  list(APPEND LIBUNWIND_LINK_FLAGS
       "-compatibility_version 1"
       "-install_name /usr/lib/libunwind.1.dylib")

  if (CMAKE_OSX_DEPLOYMENT_TARGET STREQUAL "10.6")
    list(APPEND LIBUNWIND_LINK_FLAGS
         "-current_version ${LIBUNWIND_VERSION}"
         "/usr/lib/libSystem.B.dylib")
  endif ()
endif ()

string(REPLACE ";" " " LIBUNWIND_COMPILE_FLAGS "${LIBUNWIND_COMPILE_FLAGS}")
string(REPLACE ";" " " LIBUNWIND_CXX_FLAGS "${LIBUNWIND_CXX_FLAGS}")
string(REPLACE ";" " " LIBUNWIND_LINK_FLAGS "${LIBUNWIND_LINK_FLAGS}")

set_target_properties(unwind
                      PROPERTIES
                        COMPILE_FLAGS "${CMAKE_COMPILE_FLAGS} ${LIBUNWIND_COMPILE_FLAGS}"
                        LINK_FLAGS    "${CMAKE_LINK_FLAGS} ${LIBUNWIND_LINK_FLAGS}"
                        OUTPUT_NAME   "unwind"
                        VERSION       "1.0"
                        SOVERSION     "1")
set_property(SOURCE ${LIBUNWIND_CXX_SOURCES}
             APPEND_STRING PROPERTY COMPILE_FLAGS "${LIBUNWIND_CXX_FLAGS}")

install(TARGETS unwind
        LIBRARY DESTINATION lib${LLVM_LIBDIR_SUFFIX}
        ARCHIVE DESTINATION lib${LLVM_LIBDIR_SUFFIX})

=== unit-tests/test-cases/DYLD_VERSIONED_FRAMEWORK_PATH-basic/Makefile ===
##
# Copyright (c) 2010 Apple Inc. All rights reserved.
#
# @APPLE_LICENSE_HEADER_START@
# 
# This file contains Original Code and/or Modifications of Original Code
# as defined in and that are subject to the Apple Public Source License
# Version 2.0 (the 'License'). You may not use this file except in
# compliance with the License. Please obtain a copy of the License at
# http://www.opensource.apple.com/apsl/ and read it before using this
# file.
# 
# The Original Code and all software distributed under the License are
# distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
# EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
# INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
# Please see the License for the specific language governing rights and
# limitations under the License.
# 
# @APPLE_LICENSE_HEADER_END@
##
TESTROOT = ../..
include ${TESTROOT}/include/common.makefile

PWD = $(shell pwd)

ifeq "$(OS_NAME)" "iPhoneOS"
	CHECK = check-ios
else
	CHECK = check-macosx
endif


all-check: all $(CHECK)

check: $(CHECK)

check-ios:
	./main 10

check-macosx:
	./main 10
	export DYLD_VERSIONED_FRAMEWORK_PATH="${PWD}/alt11" && ./main 11 "alt11/Foo.framework/Versions/A/Foo"
	export DYLD_VERSIONED_FRAMEWORK_PATH="${PWD}/alt9" && ./main 10
	export DYLD_VERSIONED_FRAMEWORK_PATH="${PWD}/alt9:${PWD}/alt11" && ./main 11
	export DYLD_VERSIONED_FRAMEWORK_PATH="${PWD}/alt11:${PWD}/alt12" && ./main 12

all: 
	mkdir -p Foo.framework alt11/Foo.framework/Versions/A alt9/Foo.framework alt12/Foo.framework
	${CC} ${CCFLAGS} -dynamiclib foo.c -DRESULT=10 -current_version 10 -install_name "${PWD}/Foo.framework/Foo" -o Foo.framework/Foo
	${CC} ${CCFLAGS} -I${TESTROOT}/include -o main main.c Foo.framework/Foo 
	${CC} ${CCFLAGS} -dynamiclib foo.c -DRESULT=11 -current_version 11 -install_name "${PWD}/Foo.framework/Foo" -o alt11/Foo.framework/Versions/A/Foo
	cd alt11/Foo.framework && ln -sf Versions/A/Foo
	${CC} ${CCFLAGS} -dynamiclib foo.c -DRESULT=9  -current_version 9  -install_name "${PWD}/Foo.framework/Foo" -o alt9/Foo.framework/Foo  
	${CC} ${CCFLAGS} -dynamiclib foo.c -DRESULT=12 -current_version 12 -install_name "${PWD}/Foo.framework/Foo" -o alt12/Foo.framework/Foo  


clean:
	${RM} -rf main Foo.framework alt9 alt11 alt12

=== unit-tests/test-cases/cstring-labels/Makefile ===
##
# Copyright (c) 2008 Apple Inc. All rights reserved.
#
# @APPLE_LICENSE_HEADER_START@
# 
# This file contains Original Code and/or Modifications of Original Code
# as defined in and that are subject to the Apple Public Source License
# Version 2.0 (the 'License'). You may not use this file except in
# compliance with the License. Please obtain a copy of the License at
# http://www.opensource.apple.com/apsl/ and read it before using this
# file.
# 
# The Original Code and all software distributed under the License are
# distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
# EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
# INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
# Please see the License for the specific language governing rights and
# limitations under the License.
# 
# @APPLE_LICENSE_HEADER_END@
##
TESTROOT = ../..
include ${TESTROOT}/include/common.makefile

#
# <rdar://problem/6069861> ld -r for x86_64 is changing visibility of cstring constants
#
# In order to coalesce strings from different .o files, the linker internally
# makes them weak/hidden.  Test to make sure that weak/hidden does not leak out.
#

STRING_LABEL_COUNT = 0

ifeq (${ARCH},x86_64)
	STRING_LABEL_COUNT = 3
endif
ifeq (${ARCH},i386)
	STRING_LABEL_COUNT = 1
endif



run: all

all:
	${CC} ${CCFLAGS} -c foo.c -o foo.o
	${CC} ${CCFLAGS} -c bar.c -o bar.o
	${LD} -arch ${ARCH} -r foo.o bar.o -o foobar.o
	nm -nm foobar.o | grep __cstring | grep "weak private external" | ${FAIL_IF_STDIN}
	${LD} -arch ${ARCH} -r foo.o bar.o -o foobar.o -keep_private_externs
	nm -nm foobar.o | grep __cstring | grep "weak private external" | ${FAIL_IF_STDIN}
	nm -m foobar.o | grep __cstring | wc -l | grep ${STRING_LABEL_COUNT}  | ${FAIL_IF_EMPTY}
	${CC} ${CCFLAGS} foo.o bar.o -dynamiclib -o libfoobar.dylib
	nm -m libfoobar.dylib | grep __cstring | wc -l |  egrep '[01]'  | ${FAIL_IF_EMPTY}
	${PASS_IFF} /usr/bin/true

clean:
	rm  foo.o bar.o foobar.o libfoobar.dylib

=== unit-tests/test-cases/dlclose-dylib-ref-count/Makefile ===
##
# Copyright (c) 2005 Apple Computer, Inc. All rights reserved.
#
# @APPLE_LICENSE_HEADER_START@
# 
# This file contains Original Code and/or Modifications of Original Code
# as defined in and that are subject to the Apple Public Source License
# Version 2.0 (the 'License'). You may not use this file except in
# compliance with the License. Please obtain a copy of the License at
# http://www.opensource.apple.com/apsl/ and read it before using this
# file.
# 
# The Original Code and all software distributed under the License are
# distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
# EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
# INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
# Please see the License for the specific language governing rights and
# limitations under the License.
# 
# @APPLE_LICENSE_HEADER_END@
##
TESTROOT = ../..
include ${TESTROOT}/include/common.makefile

all-check: all check

check:
	./main

all: 
	${CC} ${CCFLAGS} -dynamiclib base.c -o libbase.dylib
	${CC} ${CCFLAGS} -dynamiclib foo.c libbase.dylib -o libfoo.dylib
	${CC} ${CCFLAGS} -dynamiclib bar.c libbase.dylib -o libbar.dylib
	${CC} ${CCFLAGS} -I${TESTROOT}/include main.c  -o main 


clean:
	${RM} ${RMFLAGS} *~ main libfoo.dylib libbar.dylib libbase.dylib

=== unit-tests/test-cases/dlclose-order/Makefile ===
##
# Copyright (c) 2013 Apple Computer, Inc. All rights reserved.
#
# @APPLE_LICENSE_HEADER_START@
# 
# This file contains Original Code and/or Modifications of Original Code
# as defined in and that are subject to the Apple Public Source License
# Version 2.0 (the 'License'). You may not use this file except in
# compliance with the License. Please obtain a copy of the License at
# http://www.opensource.apple.com/apsl/ and read it before using this
# file.
# 
# The Original Code and all software distributed under the License are
# distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
# EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
# INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
# Please see the License for the specific language governing rights and
# limitations under the License.
# 
# @APPLE_LICENSE_HEADER_END@
##
TESTROOT = ../..
include ${TESTROOT}/include/common.makefile

# foo depends on bar depends on baz
# foo links with baz then bar
# verify that baz terminators run before bar terminators


all-check: all check

check:
	./main libfoo.dylib
	./main libfoo2.dylib

all:
	${CC} ${CCFLAGS}   -dynamiclib base.c -o libbase.dylib
	${CXX} ${CXXFLAGS} -dynamiclib baz.cxx libbase.dylib -o libbaz.dylib
	${CXX} ${CXXFLAGS} -dynamiclib bar.cxx libbaz.dylib libbase.dylib -o libbar.dylib
	${CC} ${CCFLAGS}   -dynamiclib foo.c libbar.dylib libbaz.dylib  -o libfoo.dylib
	${CC} ${CCFLAGS}   -dynamiclib foo.c libbaz.dylib libbar.dylib  -o libfoo2.dylib
	${CC} ${CCFLAGS}   main.c libbase.dylib -I${TESTROOT}/include  -o main


clean:
	${RM} ${RMFLAGS} *~ main libfoo.dylib libfoo2.dylib libbaz.dylib libbar.dylib libbase.dylib

=== unit-tests/test-cases/dlopen-search-leak/Makefile ===
##
# Copyright (c) 2007-2009 Apple Inc. All rights reserved.
#
# @APPLE_LICENSE_HEADER_START@
# 
# This file contains Original Code and/or Modifications of Original Code
# as defined in and that are subject to the Apple Public Source License
# Version 2.0 (the 'License'). You may not use this file except in
# compliance with the License. Please obtain a copy of the License at
# http://www.opensource.apple.com/apsl/ and read it before using this
# file.
# 
# The Original Code and all software distributed under the License are
# distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
# EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
# INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
# Please see the License for the specific language governing rights and
# limitations under the License.
# 
# @APPLE_LICENSE_HEADER_END@
##
TESTROOT = ../..
include ${TESTROOT}/include/common.makefile


#
# verify there are no leaks with dlopen/close on success and failure
#

# leaks does not work on rosetta processes
CHECK = check-real
ifeq "ppc" "$(ARCH)"
	MACHINE =  $(shell arch)
	ifeq "i386" "$(MACHINE)"
		CHECK = check-xfail
	endif
endif

all-check: all check

check: ${CHECK}

check-real:
	DYLD_LIBRARY_PATH=hide:other:places && ./main 

check-xfail:
	echo "XFAIL dlopen-leak"; 
	
	
all: main


libfoo.dylib : foo.c 
	${CC} foo.c -dynamiclib -o libfoo.dylib 

hide/libfoo.dylib :
	mkdir hide
	touch hide/libfoo.dylib
	
other/libfoo.dylib :
	mkdir other
	touch other/libfoo.dylib

main : main.c libfoo.dylib hide/libfoo.dylib other/libfoo.dylib
	${CC} ${CCFLAGS} -I${TESTROOT}/include main.c -o main 



clean:
	${RM} ${RMFLAGS} *~  main libfoo.dylib hide other

=== unit-tests/test-cases/dlopen_preflight-leak-image-deny-single/Makefile ===
##
# Copyright (c) 2007-2008 Apple Inc. All rights reserved.
#
# @APPLE_LICENSE_HEADER_START@
# 
# This file contains Original Code and/or Modifications of Original Code
# as defined in and that are subject to the Apple Public Source License
# Version 2.0 (the 'License'). You may not use this file except in
# compliance with the License. Please obtain a copy of the License at
# http://www.opensource.apple.com/apsl/ and read it before using this
# file.
# 
# The Original Code and all software distributed under the License are
# distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
# EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
# INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
# Please see the License for the specific language governing rights and
# limitations under the License.
# 
# @APPLE_LICENSE_HEADER_END@
##
TESTROOT = ../..
include ${TESTROOT}/include/common.makefile


#
# verify there are no leaks with dlopen_preflight() if a non-batch image state handler
# denies the load
# <rdar://problem/6169686> Leaked fSegmentsArray and image segments during failed dlopen_preflight
#


# leaks does not work on rosetta processes
CHECK = check-real
ifeq "ppc" "$(ARCH)"
	MACHINE =  $(shell arch)
	ifeq "i386" "$(MACHINE)"
		CHECK = check-xfail
	endif
endif

all-check: all check

check: ${CHECK}

check-real:
	./main 

check-xfail:
	echo "XFAIL dlopen-leak"; 

all: main

libfoo.dylib : foo.c 
	${CC} foo.c -dynamiclib -o libfoo.dylib 

main : main.c libfoo.dylib
	${CC} ${CCFLAGS} -I${TESTROOT}/include main.c -o main 


clean:
	${RM} ${RMFLAGS} *~  main libfoo.dylib

=== unit-tests/test-cases/eh-coalescing-r/Makefile ===
##
# Copyright (c) 2008 Apple Inc. All rights reserved.
#
# @APPLE_LICENSE_HEADER_START@
# 
# This file contains Original Code and/or Modifications of Original Code
# as defined in and that are subject to the Apple Public Source License
# Version 2.0 (the 'License'). You may not use this file except in
# compliance with the License. Please obtain a copy of the License at
# http://www.opensource.apple.com/apsl/ and read it before using this
# file.
# 
# The Original Code and all software distributed under the License are
# distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
# EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
# INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
# Please see the License for the specific language governing rights and
# limitations under the License.
# 
# @APPLE_LICENSE_HEADER_END@
##
TESTROOT = ../..
include ${TESTROOT}/include/common.makefile


SHELL = bash # use bash shell so we can redirect just stderr


#
#
#   <rdar://problem/5726215> comdat warnings in ld -r
#
#
run: all

all:
	${CXX} ${CCXXFLAGS} foo.cxx -c -o foo.o
	${CXX} ${CCXXFLAGS} bar.cxx -c -o bar.o
	${CXX} ${CCXXFLAGS} baz.cxx -c -o baz.o
	${LD} -r foo.o bar.o baz.o -o foobarbaz.o 2> warnings.log
	grep warning warnings.log | ${PASS_IFF_EMPTY}


clean:
	rm  foo.o bar.o baz.o foobarbaz.o warnings.log

=== debian/changelog ===
virtuoso-opensource (7.2.2) unstable; urgency=medium

  * Fixed debian packaging of the Virtuoso .NET adapter
 
 -- OpenLink Virtuoso Maintainer <vos.admin@openlinksw.com>  Wed, 09 Dec 2015 21:00:00 +0100

virtuoso-opensource (7.2) unstable; urgency=low

  * Remove openjdk-6-jdk and virtjdbc4.jar from libvirtjdbc0 target

 -- OpenLink Virtuoso Maintainer <vos.admin@openlinksw.com>  Mon, 11 May 2015 15:44:00 +0100

virtuoso-opensource (7.1) unstable; urgency=low

  * Misc minor packaging fixes

 -- OpenLink Virtuoso Maintainer <vos.admin@openlinksw.com>  Mon, 04 Aug 2014 17:44:00 +0100

virtuoso-opensource (6.1.7) unstable; urgency=low

  * New release

 -- OpenLink Virtuoso Maintainer <vos.admin@openlinksw.com>  Wed, 22 Jul 2013 17:00:00 +0100

virtuoso-opensource (6.1.6) unstable; urgency=low

  * New release

 -- OpenLink Virtuoso Maintainer <vos.admin@openlinksw.com>  Wed, 01 Aug 2012 17:00:00 +0100

virtuoso-opensource (6.1.5) unstable; urgency=low

  * New release

 -- OpenLink Virtuoso Maintainer <vos.admin@openlinksw.com>  Thu, 15 Mar 2012 17:16:24 +0100

virtuoso-opensource (6.1.4) unstable; urgency=low

  * New release

 -- OpenLink Virtuoso Maintainer <vos.admin@openlinksw.com>  Fri, 28 Oct 2011 22:01:10 +0100

virtuoso-opensource (6.1.3) unstable; urgency=low

  * New release

 -- OpenLink Virtuoso Maintainer <vos.admin@openlinksw.com>  Fri, 25 Mar 2011 22:32:29 +0100

virtuoso-opensource (6.1.2) unstable; urgency=low

  * New release

 -- OpenLink Virtuoso Maintainer <vos.admin@openlinksw.com>  Fri, 09 Jul 2010 17:37:40 +0100

=== debian/control ===
Source: virtuoso-opensource
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Obey Arthur Liu <arthur@milliways.fr>
Standards-Version: 3.9.2
Homepage: http://virtuoso.openlinksw.com/wiki/main/Main/
Vcs-Browser: https://alioth.debian.org/plugins/scmgit/cgi-bin/gitweb.cgi?p=pkg-virtuoso/pkg-virtuoso.git
Vcs-Git: git://scm.alioth.debian.org/git/pkg-virtuoso/pkg-virtuoso.git
Build-Depends: cdbs, debhelper (>= 7), quilt, autotools-dev, autoconf (>=2.57),
 automake (>=1.10), libtool (>=1.5.16), flex (>=2.5.4), bison (>=1.35),
 gperf (>=2.7.2), gawk (>=3.1.1), m4 (>=1.4.1), make (>=3.79.1),
 libssl-dev (>=0.9.7), libreadline-dev, zlib1g-dev, libxml2-dev, libpcre3-dev,
 libldap2-dev, net-tools,
 mono-gmcs (>= 1.0) [i386 kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390],
 cli-common-dev (>= 0.4.4) [i386 kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390],
 libmono-corlib2.0-cil (>= 1.2.6) [i386 kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390],
 libmono-system-data2.0-cil (>= 1.0) [i386 kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390],
 libmono-system2.0-cil (>= 1.2.6) [i386 kfreebsd-i386 powerpc amd64 kfreebsd-amd64 ia64 arm armeb armel sparc s390],
 docbook2x, po-debconf, libmagickwand-dev, openjdk-7-jdk, lzma-dev, libbz2-dev

Package: virtuoso-nepomuk
Architecture: all
Depends: ${misc:Depends}, virtuoso-minimal
Description: transitional package for virtuoso-minimal
 Virtuoso is a high-performance object-relational SQL database. As a
 database, it provides transactions, a smart SQL compiler, powerful
 stored-procedure language with optional Java and .Net server-side
 hosting, hot backup, SQL-99 support and more. It has all major
 data-access interfaces, such as ODBC, JDBC, ADO .Net and OLE/DB.
 .
 OpenLink Virtuoso supports SPARQL embedded into SQL for querying RDF
 data stored in Virtuoso's database. SPARQL benefits from low-level
 support in the engine itself, such as SPARQL-aware type-casting rules
 and a dedicated IRI data type.
 .
 This is a dummy binary package to ensure the safe transition to the
 virtuoso-minimal package.

Package: virtuoso-opensource
Architecture: all
Depends: virtuoso-opensource-7, ${misc:Depends}
Recommends: virtuoso-server, virtuoso-vsp-startpage, virtuoso-vad-conductor
Suggests: virtuoso-vad-doc, virtuoso-vad-demo, virtuoso-vad-tutorial,
 virtuoso-vad-rdfmappers, virtuoso-vad-sparqldemo, virtuoso-vad-syncml,
 virtuoso-vad-bpel, virtuoso-vad-isparql, virtuoso-vad-ods
Description: high-performance database
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 Virtuoso supports SPARQL embedded into SQL for querying RDF data stored
 in its database. SPARQL benefits from low-level support in the engine
 itself, such as SPARQL-aware type-casting rules and a dedicated IRI data
 type.
 .
 Install this metapackage for the full suite of packages that make up
 Virtuoso OSE ("Open-Source Edition").

Package: virtuoso-server
Architecture: all
Depends: virtuoso-opensource-7, ${misc:Depends}
Description: high-performance database - server dependency package
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This is an empty package depending on the current "best" version of the
 Virtuoso server framework, as recommended by the maintainers (currently
 virtuoso-opensource-7). Install this package if in doubt about
 which version you need.

Package: virtuoso-minimal
Architecture: all
Depends: virtuoso-opensource-7-bin, libvirtodbc0, ${misc:Depends}
Replaces: virtuoso-nepomuk (<< 6.1.2+dfsg1-1ubuntu1)
Breaks: virtuoso-nepomuk (<< 6.1.2+dfsg1-1ubuntu1)
Description: high-performance database - core dependency package
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This is an empty package depending on the current "best" version of the
 core Virtuoso binaries, as recommended by the maintainers (currently
 virtuoso-opensource-7-bin). This should usually be depended on by
 all packages which use Virtuoso as an embedded database.

Package: virtuoso-opensource-7
Architecture: any
Depends: virtuoso-opensource-7-common (= ${binary:Version}),
 virtuoso-opensource-7-bin (= ${binary:Version}),
 libvirtodbc0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Breaks: virtuoso-opensource-6.0 (<< 6.1.2+dfsg1-1ubuntu1)
Description: high-performance database - support files
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This package provides the Virtuoso server framework.

Package: virtuoso-opensource-7-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: virtuoso-opensource-6.0-common
Replaces: virtuoso-opensource-6.0-common
Description: high-performance database - common files
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This package contains files common to all versions of Virtuoso.

Package: virtuoso-opensource-7-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: virtuoso-opensource-6.0-bin
Replaces: virtuoso-opensource-6.0-bin
Description: high-performance database - binaries
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This package contains the core Virtuoso binaries.

Package: virtuoso-vsp-startpage
Architecture: all
Depends: ${misc:Depends}, virtuoso-opensource
Description: high-performance database - web interface files
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This package contains the files for Virtuoso's web interface.

Package: virtuoso-vad-conductor
Architecture: all
Depends: ${misc:Depends}, virtuoso-opensource
Description: high-performance database - conductor module
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This package contains the Virtuoso Application Distribution module
 for the administration interface.

Package: virtuoso-vad-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, virtuoso-opensource
Description: high-performance database - documentation module
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This package contains the Virtuoso Application Distribution module
 for the documentation.

Package: virtuoso-vad-demo
Section: doc
Architecture: all
Depends: ${misc:Depends}, virtuoso-opensource
Description: high-performance database - demo module
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This package contains the Virtuoso Application Distribution module
 for the demonstration application.

Package: virtuoso-vad-tutorial
Section: doc
Architecture: all
Depends: ${misc:Depends}, virtuoso-opensource
Description: high-performance database - tutorial module
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This package contains the Virtuoso Application Distribution module
 for the tutorial application.

Package: virtuoso-vad-rdfmappers
Architecture: all
Depends: ${misc:Depends}, virtuoso-opensource
Description: high-performance database - RDF mappers module
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This package contains the Virtuoso Application Distribution module
 for the RDF mappers application.

Package: virtuoso-vad-sparqldemo
Architecture: all
Depends: ${misc:Depends}, virtuoso-opensource
Description: high-performance database - SPARQL demo module
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This package contains the Virtuoso Application Distribution module
 for the SPARQL demo application.

Package: virtuoso-vad-syncml
Architecture: all
Depends: ${misc:Depends}, virtuoso-opensource
Description: high-performance database - SyncML module
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side
 Java or .NET, and more. It supports all major data-access interfaces,
 including ODBC, JDBC, ADO.NET, and OLE/DB.
 .
 This package contains the Virtuoso Application Distribution module
 for Synchronization Markup Language support.

Package: virtuoso-vad-bpel
Architecture: all
Depends: ${misc:Depends}, virtuoso-opensource
Description: high-performance database - BPEL module
 OpenLink Virtuoso is a high-performance object-relational SQL database.
 It provides transactions, a smart SQL compiler, hot backup, SQL:1999
 support, a powerful stored-procedure language supporting server-side

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk
include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/utils.mk

DEB_AUTO_UPDATE_ACLOCAL = 1.14
DEB_AUTO_UPDATE_AUTOCONF = 2.61
DEB_AUTO_UPDATE_AUTOMAKE = 1.14
DEB_AUTO_UPDATE_LIBTOOL = pre

DEB_AUTOMAKE_ARGS += -Wno-portability

JDK6PATH = $(shell dpkg -L openjdk-6-jdk | grep "/usr/lib/jvm/java-6-openjdk" | cut -d - -f 1-4| cut -d / -f 1-5 | sort -u )
ifeq ($(JDK6PATH),)
JDK6PATH=no
endif

JDK7PATH = $(shell dpkg -L openjdk-7-jdk | grep "/usr/lib/jvm/java-7-openjdk" | cut -d - -f 1-4| cut -d / -f 1-5 | sort -u)
ifeq ($(JDK7PATH),)
JDK7PATH=no
endif

DEB_CONFIGURE_EXTRA_FLAGS = --with-layout=debian \
		--program-transform-name='s/isql$$/isql-vt/;s/isqlw/isqlw-vt/' \
		--with-readline \
		--without-internal-zlib \
		--enable-maintainer-mode \
		--without-iodbc \
		--enable-demo-vad \
		--enable-tutorial-vad \
		--enable-isparql-vad \
		--enable-ods-vad \
		--enable-rdfmappers-vad \
		--enable-sparqldemo-vad \
		--enable-syncml-vad \
		--enable-bpel-vad \
		--with-jdk4=$(JDK6PATH) \
		--with-jdk4_1=$(JDK7PATH)

ifeq ($(DEB_BUILD_ARCH),alpha)
		EXTRA_LDFLAGS += -Wl,--no-relax
endif

DEB_CONFIGURE_SCRIPT_ENV += \
		LDFLAGS="-Wl,-z,defs -Wl,--no-undefined -Wl,--as-needed $(EXTRA_LDFLAGS)" \
		MONO_DISABLE_SHM=1 \
        DEBIANPKG=virtuoso-opensource-7

DEB_DH_INSTALL_ARGS := --sourcedir=debian/tmp

# update-rc.d is manually called in virtuoso-opensource-7.postinst
# See note there.
DEB_DH_INSTALLINIT_ARGS += --noscripts

# Disabled for now
#DEB_MAKE_INVOKE += -j
#.NOTPARALLEL:

clean::
	debconf-updatepo

pre-build::
	./autogen.sh

build/virtuoso-opensource-7::
	cd debian; find . -name "*.?.xml" -exec docbook2x-man --solinks {} \;

build/libvirtmono0-cil::
	$(MAKE) -C binsrc/VirtuosoClient.Net
	chmod -x binsrc/VirtuosoClient.Net/OpenLink.Data.Virtuoso.dll

cleanbuilddir/libvirtmono0-cil::
	$(MAKE) -C binsrc/VirtuosoClient.Net clean

binary-install/libvirtmono0-cil::
	dh_installcligac

binary-predeb/libvirtmono0-cil::
	dh_makeclilibs
	dh_clideps -d

get-orig-source:
	-uscan --download --verbose
